#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDrag>
#include <QMimeData>
#include <QDropEvent>
#include <QDragEnterEvent>

void MainWindow::on_pushButton_pressed ()
{
    QDrag * drag = new QDrag (this);
    QMimeData * mime = new QMimeData;
    mime->setText ("Hello");
    mime->setColorData (QColor ("red"));
    drag->setMimeData (mime);
    drag->exec ();
}

class MyButton : public QPushButton
{
protected:
    void dragEnterEvent (QDragEnterEvent * event)
    {
        const QMimeData * mime = event->mimeData ();
        if (mime->hasText ())
           event->setAccepted (true);
    }

    void dropEvent (QDropEvent * event)
    {
        const QMimeData * mime = event->mimeData ();
        if (mime->hasText ())
            this->setText (mime->text());
    }
};

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    MyButton * b = new MyButton;
    b->setText ("My Button");
    b->setParent (this);
    b->setGeometry (200, 100, 200, 100);
    b->setAcceptDrops (true);
}

MainWindow::~MainWindow()
{
    delete ui;
}

